/* ========================================================================
* @author Grant McKenzie (grant.mckenzie@geog.ucsb.edu
* @date March 2014
* @course mat259
* @description The cube with book cover front
* ====================================================================== */

void TexturedCube(PImage tex, Float scale, float pages, color c) {
  colorMode(RGB, 255);
  fill(255);
  noStroke();
  beginShape(QUADS);
  texture(tex);
  
  // Given one texture and six faces, we can easily set up the uv coordinates
  // such that four of the faces tile "perfectly" along either u or v, but the other
  // two faces cannot be so aligned.  This code tiles "along" u, "around" the X/Z faces
  // and fudges the Y faces - the Y faces are arbitrarily aligned such that a
  // rotation along the X axis will put the "top" of either texture at the "top"
  // of the screen, but is not otherwised aligned with the X/Z faces. (This
  // just affects what type of symmetry is required if you need seamless
  // tiling all the way around the cube)
  
  // Front face
  vertex(-1*scale, -1*scale,  1*pages, 0, 0);
  vertex( 1*scale, -1*scale,  1*pages, 1*scale, 0);
  vertex( 1*scale,  1*scale,  1*pages, 1*scale, 1*scale);
  vertex(-1*scale,  1*scale,  1*pages, 0, 1*scale);
  endShape();
  // -Z "back" face
  /*vertex( 1*scale, -1*scale, -1*pages*scale, 0, 0);
  vertex(-1*scale, -1*scale, -1*pages*scale, 1*scale, 0);
  vertex(-1*scale,  1*scale, -1*pages*scale, 1*scale, 1*scale);
  vertex( 1*scale,  1*scale, -1*pages*scale, 0, 1*scale); */
 beginShape(QUADS);
 fill(c);
 // stroke(c2);
  // +Y "bottom" face
  vertex(-1*scale,  1*scale,  1*pages, 0, 0);
  vertex( 1*scale,  1*scale,  1*pages, 1*scale, 0);
  vertex( 1*scale,  1*scale, -1*scale, 1*scale, 1*scale);
  vertex(-1*scale,  1*scale, -1*scale, 0, 1*scale);

  // -Y "top" face
  vertex(-1*scale, -1*scale, -1*scale, 0, 0);
  vertex( 1*scale, -1*scale, -1*scale, 1*scale, 0);
  vertex( 1*scale, -1*scale,  1*pages, 1*scale, 1*scale);
  vertex(-1*scale, -1*scale,  1*pages, 0, 1*scale);

  // +X "right" face
  vertex( 1*scale, -1*scale,  1*pages, 0, 0);
  vertex( 1*scale, -1*scale, -1*scale, 1*scale, 0);
  vertex( 1*scale,  1*scale, -1*scale, 1*scale, 1*scale);
  vertex( 1*scale,  1*scale,  1*pages, 0, 1*scale);

  // -X "left" face
  vertex(-1*scale, -1*scale, -1*scale, 0, 0);
  vertex(-1*scale, -1*scale,  1*pages, 1*scale, 0);
  vertex(-1*scale,  1*scale,  1*pages, 1*scale, 1*scale);
  vertex(-1*scale,  1*scale, -1*scale, 0, 1*scale); 

  endShape();
}
